//MxRock.cs


datablock AudioProfile(MxRockExplosionSound)
{
   filename    = "./MxRockHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(MxRockFireSound)
{
   filename    = "./MxRockFire.wav";
   description = AudioClose3d;
   preload = true;
};


//MxRock trail
datablock ParticleData(MxRockTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/ring";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.75 0.75 0.75 0.3";
	colors[1]	= "0.75 0.75 0.75 0.0";
	colors[2]	= "1 1 1 0.0";
	sizes[0]	= 0.15;
	sizes[1]	= 0.35;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(MxRockTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MxRockTrailParticle;

   useEmitterColors = true;
   uiName = "MxRock Trail";
};


//effects
datablock ParticleData(MxRockExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./MxRockChunk";
	//animTexName		= "./MxRockChunk";

	// Interpolation variables
	colors[0]	= "0.5 0.5 0.5 0.9";
	colors[1]	= "0.5 0.5 0.5 0.0";
	sizes[0]	= 2.0;
	sizes[1]	= 3.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
};

datablock ParticleEmitterData(MxRockExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MxRockExplosionParticle";

   uiName = "MxRock Smoke";
   emitterNode = TenthEmitterNode;
};

datablock ParticleData(MxRockExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "1.0 1.0 1.0 1.0";
	colors[1]	= "1.0 1.0 1.0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 0.2;
};

datablock ParticleEmitterData(MxRockExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 7;
   ejectionVelocity = 3;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MxRockExplosionParticle2";

   useEmitterColors = true;
   uiName = "MxRock Hit";
   emitterNode = HalfEmitterNode;
};

datablock ExplosionData(MxRockExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = MxRockExplosionSound;

   emitter[0] = MxRockExplosionEmitter;
   emitter[1] = MxRockExplosionEmitter2;
   //particleDensity = 30;
   //particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   //impulse
   impulseRadius = 5;
   impulseForce = 5;

   //radius damage
   radiusDamage        = 10;
   damageRadius        = 3.5;
};

//projectile
AddDamageType("MxRockDirect",   '<bitmap:add-ons/Weapon_MxRock/CI_MxRock> %1',       '%2 <bitmap:add-ons/Weapon_MxRock/CI_MxRock> %1',1,1);
AddDamageType("MxRockRadius",   '<bitmap:add-ons/Weapon_MxRock/CI_MxRockRadius> %1', '%2 <bitmap:add-ons/Weapon_MxRock/CI_MxRockRadius> %1',1,0);
datablock ProjectileData(MxRockProjectile)
{
   projectileShapeName = "./MxRockProjectile.dts";
   directDamage        = 10;
   directDamageType  = $DamageType::MxRockDirect;
   radiusDamageType  = $DamageType::MxRockRadius;
   impactImpulse	   = 5;
   verticalImpulse	   = 5;
   explosion           = MxRockExplosion;
   particleEmitter     = MxRockTrailEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Rock";
};


//////////
// item //
//////////
datablock ItemData(MxRockItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MxRock.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Rock";
	iconName = "./icon_MxRock";
	doColorShift = true;
	colorShiftColor = "1.000 1.000 1.00 1.000";

	 // Dynamic properties defined by the scripts
	image = MxRockImage;
	canDrop = true;
};

//function MxRock::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MxRockImage)
{
   // Basic Item properties
   shapeFile = "./MxRock.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MxRockItem;
   ammo = " ";
   projectile = MxRockProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= MxRockFireSound;
};


function MxRockImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastHESlot = %obj.currTool;
}

function MxRock::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function MxRockImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::OnFire(%this, %obj, %slot);

	%currSlot = %obj.lastHESlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}

function MxRock::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

datablock DecalData(MxRockIcon)
{
   textureName = "Add-Ons/Weapon_MxRock/icon_MxRock";
};